#ifndef LSM_TRIE_INTERNAL
#define LSM_TRIE_INTERNAL

#include "lsm/bt_internal.h"
#include "lsm/str_internal.h"
#include "lsm/trie.h"

/**
 * A node inside a trie structure
 */
typedef struct lsm_trie_node {
  lsm_bt bt;
  lsm_str skip;
  void *data;
} lsm_trie_node;

/**
 * Allocate and initialize a new trie node
 *
 * @param ptr pointer to store new node pointer
 */
lsm_error lsm_trie_node_init(lsm_trie_node **ptr);

/**
 * Deallocate a trie node
 *
 * @param node node to deallocate
 */
void lsm_trie_node_free(lsm_trie_node *node);

struct lsm_trie {
  lsm_trie_node *root;
  uint64_t size;
};

#endif
