#include <time.h>

#include "log.h"

const char *log_level_names[] = {"DEBUG", "INFO ", "WARN ", "ERROR",
                                 "CRITICAL"};

log_level _log_level = log_level_debug;

void _lander_log(log_level level, FILE *f, const char *fmt, ...) {
  if (level < _log_level) {
    return;
  }

  // Log to stdout by default
  f = (f == NULL) ? stdout : f;

  char date_str[32];

  time_t now = time(NULL);
  strftime(date_str, sizeof(date_str) - 1, "%Y-%m-%d %H:%M:%S",
           localtime(&now));
  fprintf(f, "[%s][%s] ", date_str, log_level_names[level]);

  va_list ap;
  va_start(ap, fmt);
  vfprintf(f, fmt, ap);
  va_end(ap);

  fprintf(f, "\n");
}
